clc;
clear;

tic;
d0 = [1000 200];
options = optimoptions('patternsearch', 'UseCompletePoll', false, 'AccelerateMesh', true, 'MeshExpansionFactor', 2, 'InitialMeshSize', 100, 'MeshTolerance', 1e-2, 'Display', 'iter', 'UseCompletePoll', true, 'UseParallel', false, 'UseVectorized', false, 'PlotFcns', {'psplotbestf', 'psplotmeshsize', 'psplotbestx'});
[d,minPf,exitflag,output] = patternsearch(@Cost,d0,[],[],[],[],[500 100],[2000 400],[],options);
toc;

function TotalCost = Cost(d)
    % Open the input file and generate a new one by changing the current value of decision variables
    fin = fopen('Explicit_LSF.txt', 'r');
    fout = fopen('Explicit_LSF_Modified.txt', 'w');
    while ~feof(fin)
        s = fgetl(fin);
        for i=1:2
            target = strcat('ObjectName: d', int2str(i));
            sNew = s;
            if strfind(s, target) > 0
               OldDecisionChr = extractAfter(s,'CurrentValue: ');     
               NewDecisionVar = d(i);     
               sNew = strrep(s, OldDecisionChr, num2str(NewDecisionVar));
               break;
            end
        end
         
        fprintf(fout,'%s\n',sNew);
        %disp(s)
    end
    fclose(fin);
    fclose(fout);
    
    % Run Rtx by; modify the address to where thr Rtx binary is lcoated on your system 
    % Use "nogui" to run Rtx in terminal, i.e., with no graphical user interface 
    system('"D:\Work\Research\Rt\Rt Files\Exe\Rtx-Release-x64\Rtx.exe" nogui "Explicit_LSF_Modified.txt"');

    % Reading outputs
    fraed = fopen('myoutput.txt', 'r');
    while ~feof(fraed)
        s = fgetl(fraed);
        target = 'pf';
        if strfind(s, target) > 0
           pfChr = extractAfter(s,'pf = ');
           pf = str2double(pfChr);
           %disp(pf);
        end   
    end
    fclose(fraed);
    
    Co = d(1) + 5 * d(2);
    Cf = 4000;
    TotalCost = Co + Cf * pf;
end